#############################################################################
#                                                                           #
#                   Christmas Soldering Kit Example Script                  #
#                                                                           #
#                     AusThai Solutions - www.austhai.com                   #
#---------------------------------------------------------------------------#
#    Revision: 1.0                                                          #
#    Date:     01/12/15                                                     #
#    Author:   Thomas Mc Neill                                              #
#---------------------------------------------------------------------------#
#  This script demonstrates the functions of the Christmas Soldering Kit.   #
#  It monitors the comparator input from the light sensor. When the light   #
#  drops below the threshold a 200ms pulse is sent to the sound chip to     #
#  start the music. Then the LED light sequence is started.                 #
#                                                                           #
#  There is a main sequence that is repeasted twice then a final sequence   #
#  runs. When the final sequence has finished there is a three second pause #
#  before the script returns to check the light sensor.                     #
#                                                                           #
#  The script can be terminated at any time by pressing ctrl-C.             #
#############################################################################

import RPi.GPIO as GPIO
import time

GPIO.setmode(GPIO.BCM)  # set board mode to Broadcom

GPIO.setup(02,GPIO.OUT,initial=0)               # Pin 02 starts the music
GPIO.setup(03,GPIO.OUT,initial=0)               # Pin 03 is LED 1 (Rudolf)
GPIO.setup(04,GPIO.OUT,initial=0)               # Pin 04 is LED 2
GPIO.setup(17,GPIO.OUT,initial=0)               # Pin 17 is LED 3
GPIO.setup(27,GPIO.IN,pull_up_down=GPIO.PUD_UP) # Pin 27 is LDR Sensor

print "Press ctrl-c to end the program..."
try:
    while(1):
        time.sleep(0.1);            # wait for a 100ms
        if(GPIO.input(27)==0):
            GPIO.output(02,1)       # Start the music
            time.sleep(0.2)
            GPIO.output(02,0)  
            for x in xrange(0,2):    
                GPIO.output(03,1)   # turn on LED 1
                time.sleep(0.6)
                GPIO.output(03,0)   # turn off LED 1
                GPIO.output(04,1)   # turn on LED 2
                time.sleep(0.6)
                GPIO.output(04,0)   # turn off LED 2
                GPIO.output(17,1)   # turn on LED 3
                time.sleep(0.6)
                GPIO.output(17,0)   # turn off LED 3
                GPIO.output(04,1)   # turn on LED 2
                time.sleep(0.6)
                GPIO.output(04,0)   # turn off LED 2
                GPIO.output(03,1)   # turn on LED 1
                time.sleep(0.6)
                GPIO.output(04,1)   # turn on LED 2
                time.sleep(0.2)
                GPIO.output(17,1)   # turn on LED 3
                time.sleep(0.2)
                GPIO.output(17,0)   # turn off LED 3
                time.sleep(0.2)
                GPIO.output(04,0)   # turn off LED 2
                time.sleep(0.2)
                GPIO.output(03,0)   # turn off LED 1
                time.sleep(0.6)

                GPIO.output(03,1)   # turn on LED 1
                time.sleep(0.6)
                GPIO.output(03,0)   # turn off LED 1
                GPIO.output(04,1)   # turn on LED 2
                time.sleep(0.6)
                GPIO.output(04,0)   # turn off LED 2
                GPIO.output(17,1)   # turn on LED 3
                time.sleep(0.6)
                GPIO.output(17,0)   # turn off LED 3
                time.sleep(0.6)

                GPIO.output(03,1)   # turn on LED 1
                time.sleep(0.6)
                GPIO.output(03,0)   # turn off LED 1
                GPIO.output(04,1)   # turn on LED 2
                time.sleep(0.6)
                GPIO.output(04,0)   # turn off LED 2
                GPIO.output(17,1)   # turn on LED 3
                time.sleep(0.6)
                GPIO.output(17,0)   # turn off LED 3
                GPIO.output(04,1)   # turn on LED 2
                time.sleep(0.6)
                GPIO.output(04,0)   # turn off LED 2
                GPIO.output(03,1)   # turn on LED 1
                time.sleep(0.6)
                GPIO.output(04,1)   # turn on LED 2
                time.sleep(0.2)
                GPIO.output(17,1)   # turn on LED 3
                time.sleep(0.2)
                GPIO.output(17,0)   # turn off LED 3
                time.sleep(0.2)
                GPIO.output(04,0)   # turn off LED 2
                time.sleep(0.2)
                GPIO.output(03,0)   # turn off LED 1
                time.sleep(0.6)

                GPIO.output(03,1)   # turn on LED 1
                GPIO.output(04,1)   # turn on LED 2
                GPIO.output(17,1)   # turn on LED 3
                time.sleep(0.6)
                GPIO.output(03,0)   # turn off LED 1
                GPIO.output(04,0)   # turn off LED 2
                GPIO.output(17,0)   # turn off LED 3
                time.sleep(0.6)

            GPIO.output(03,1)       # turn on LED 1
            time.sleep(0.6)
            GPIO.output(04,1)       # turn on LED 2
            time.sleep(0.2)
            GPIO.output(17,1)       # turn on LED 3
            time.sleep(0.2)
            GPIO.output(17,0)       # turn off LED 3
            time.sleep(0.2)
            GPIO.output(04,0)       # turn off LED 2
            time.sleep(0.2)
            GPIO.output(03,0)       # turn off LED 1
            time.sleep(0.6)

            GPIO.output(03,1)       # turn on LED 1
            GPIO.output(04,1)       # turn on LED 2
            GPIO.output(17,1)       # turn on LED 3
            time.sleep(1.2)
            GPIO.output(03,0)       # turn off LED 1
            GPIO.output(04,0)       # turn off LED 2
            GPIO.output(17,0)       # turn off LED 3
            time.sleep(3)           # Wait for 3 seconds before we start again

except KeyboardInterrupt:
    GPIO.cleanup()
